-- Switchboard 0.9 by JuiCe

local HealthNag = 0;
local InCombat = 0;
local Vol = GetCVar("Sound_MusicVolume");
local XRNag = 0;
local Mounted = 0;

function Switchboard_OnLoad()
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN");
	this:RegisterEvent("CHAT_MSG_CHANNEL");
	this:RegisterEvent("CHAT_MSG_SKILL");
	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	this:RegisterEvent("PLAYER_QUITING");
	this:RegisterEvent("PLAYER_CAMPING");
	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
	this:RegisterEvent("PET_LOYALTY_GAIN");
	this:RegisterEvent("PET_LOYALTY_LOSS");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	this:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH");
	local SBFrame = CreateFrame("Frame");
	SBFrame:SetScript("OnUpdate",CheckMount);
	
	SLASH_PLAY1 = "/sbplay";
	SLASH_PLAY2 = "/sbsnd";
	SlashCmdList["PLAY"] = Play_Command;
	SLASH_STOP1 = "/sbstop";
	SLASH_STOP2 = "/sbend";
	SlashCmdList["STOP"] = Stop_Command;
	SLASH_XR1 = "/xralert"
	SlashCmdList["XR"] = XR_Command;
	SLASH_MOUNTMUSIC1 = "/mountmusic";
	SlashCmdList["MOUNTMUSIC"] = MountMusic_Command;
	
	if (UseMountMusic == nil) then
		UseMountMusic = 1;
	end
end

function Play(target,cmd)
local ext = "";
	if (cmd == 1) then
		if (strfind(target,".mp3") == nil) then
			ext = ".mp3";
		end
		PlayMusic("Interface\\AddOns\\Switchboard\\Sound\\"..target..ext);
	elseif (cmd == 2) then
		PlaySound(target);
	else
		if (strfind(target,".wav") == nil) then
			ext = ".wav";
		end
		PlaySoundFile("Interface\\AddOns\\Switchboard\\Sound\\"..target..ext);
	end
end

function Play_Command(cmd)
	if (strfind(cmd,".wav") ~= nil) then
		Play(cmd);
	elseif (strfind(cmd, ".mp3") ~= nil) then
		Play(cmd,1);
	else
		Play(cmd,2);
	end
end

function Push(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg,1,1,0);
end

function Stop_Command()
	StopMusic();
end

function XR_Command(cmd)
	if (cmd == "on") then
		XRNag = 1;
		Push("The battle horn will sound.");
	elseif (cmd == "off") then
		XRNag = 0;
		Push("The battle horn will no longer sound.");
	end
end

function MountMusic_Command(cmd)
	if (cmd == "on") then
		if (Mounted == 1) then Mounted = 0 end
		UseMountMusic = 1;
		Push("Mount Music enabled.");
	elseif (cmd == "off") then
		if (Mounted == 1) then
			StopMusic();
			SetCVar("Sound_MusicVolume",Vol);
		end
		UseMountMusic = 0;
		Push("Mount Music disabled.");
	end
end

function CheckMount()
	if (IsMounted() == 1) then
		if (Mounted ~= 1) then
			Mounted = 1;
			if (UseMountMusic == 1) then
				SetCVar("Sound_MusicVolume",1);
				Play("Mount",1);
			end
		end
	else
		if (Mounted == 1) then
			StopMusic();
			SetCVar("Sound_MusicVolume",Vol);
		end
		Mounted = 0;
	end
end

function Switchboard_OnEvent(event,param1,param2,param3,param4,param5)	
	if (strfind(event,"CHAT_MSG_WHISPER") ~= nil) then
		Play("Whisper");
	elseif (strfind(event, "COMBAT_LOG_EVENT_UNFILTERED") ~= nil) then
		if (arg4 == UnitName("player")) then
			if (param2 == "SPELL_DAMAGE" and arg18 == 1) then
				Play("Critical_Spell");
			elseif (param2 == "SWING_DAMAGE" and arg15 == 1) then
				Play("Critical_Melee");
			end
		end
	elseif (strfind(event, "CHAT_MSG_COMBAT_HONOR_GAIN") ~= nil) then
		Play("Honor");		
	elseif (strfind(event, "CHAT_MSG_CHANNEL") ~= nil) then
		if (strfind(param1, "The Crossroads is under attack!") ~= nil and XRNag == 1) then
			Play("Battle_Horn");
		end
	elseif (strfind(event, "CHAT_MSG_SKILL") ~= nil) then
		Play("Skillup");
	elseif (strfind(event, "CHAT_MSG_SYSTEM") ~= nil) then
		if (strfind(param1, "A buyer has been found for your auction of (.+)") ~= nil) then
			Play("AuctionWindowOpen",2);
		end
	elseif (strfind(event, "PLAYER_QUITING") ~= nil or strfind(event, "PLAYER_CAMPING") ~= nil) then
		Play("Quit");
	elseif (strfind(event, "PLAYER_XP_UPDATE") ~= nil) then
		Play("XP");
	elseif (strfind(event, "PLAYER_REGEN_DISABLED") ~= nil) then
		InCombat = 1;
		Play("Combat");
	elseif (strfind(event, "UNIT_HEALTH") ~= nil) then
		if (param1 == "player") then
			local MaxHP = UnitHealthMax("player");
			local HP = UnitHealth("player");
			local Pct = floor((HP / MaxHP) * 100);
			if (Pct <= 25 and InCombat == 1) then
				if (HealthNag == 0) then
					HealthNag = 1;
					SetCVar("Sound_MusicVolume",1);
					Play("Low_Health",1);
				end
			elseif (Pct > 25 and InCombat == 1) then
				if (HealthNag == 1) then
					HealthNag = 0;
					StopMusic();
					SetCVar("Sound_MusicVolume",Vol);
				end
			end
		end
	elseif (strfind(event, "PLAYER_REGEN_ENABLED") ~= nil) then
		InCombat = 0;
		local HP = UnitHealth("player");
			if (HealthNag == 1) then
				HealthNag = 0;
				StopMusic();
				SetCVar("Sound_MusicVolume",Vol);
				if (HP > 0) then
					Play("Win_Battle");
				else
					Play("Lose_Battle");
				end
			end
	elseif (strfind(event, "PET_LOYALTY_GAIN") ~= nil) then
		-- Haven't tested this yet
		-- DEFAULT_CHAT_FRAME:AddMessage("Your pet has become more loyal.");
	elseif (strfind(event, "PET_LOYALTY_LOSS") ~= nil) then
		-- Haven't tested this yet
		-- DEFAULT_CHAT_FRAME:AddMessage("Your pet has become less loyal.");
	elseif (strfind(event, "CHAT_MSG_COMBAT_FRIENDLY_DEATH") ~= nil) then
		if (param1 == "You die.") then
			InCombat = 0;
			Play("Lose_Battle");
				if (HealthNag == 1) then
					HealthNag = 0;
					StopMusic();
					SetCVar("Sound_MusicVolume",Vol);
				end
		end
	end
end
